Subject: [PATCH 3/9] gpio: Allow hogged gpios to be requested

From: [email-masked] (Johan Hovold)
Date: Tue, 28 Jul 2015 11:17:53 +0200

On Sun, Jul 19, 2015 at 04:01:42PM +0200, Markus Pargmann wrote:
> Hi Uwe,
> 
> On Fri, Jul 17, 2015 at 10:27:02PM +0200, Uwe Kleine-K?nig wrote:
> > Hello,
> > 
> > On Fri, Jul 17, 2015 at 11:32:44AM +0200, Markus Pargmann wrote:
> > > It can be useful to claim hogged gpios later, for example from
> > > userspace. This allows to set defaults for GPIOs using the hogging
> > > mechanism and override the setup later from userspace or a kernel driver.
> > > 
> > > This patch adds a check for hogged gpios to allow requesting them. If
> > > the gpio is not hogged but marked as requested, it still fails with
> > > -EBUSY.
> > > 
> > > Signed-off-by: Markus Pargmann <[email-masked]>
> > > ---
> > >  drivers/gpio/gpiolib.c | 3 ++-
> > >  1 file changed, 2 insertions(+), 1 deletion(-)
> > > 
> > > diff --git a/drivers/gpio/gpiolib.c b/drivers/gpio/gpiolib.c
> > > index bf4bd1d120c3..9f402b159cbe 100644
> > > --- a/drivers/gpio/gpiolib.c
> > > +++ b/drivers/gpio/gpiolib.c
> > > @@ -798,7 +798,8 @@ static int __gpiod_request(struct gpio_desc *desc, const char *label)
> > >  	 * before IRQs are enabled, for non-sleeping (SOC) GPIOs.
> > >  	 */
> > >  
> > > -	if (test_and_set_bit(FLAG_REQUESTED, &desc->flags) == 0) {
> > > +	if (test_and_set_bit(FLAG_REQUESTED, &desc->flags) == 0 ||
> > > +	    test_and_clear_bit(FLAG_IS_HOGGED, &desc->flags) == 1) {
> > >  		desc_set_label(desc, label ? : "?");
> > >  		status = 0;
> > I don't like this patch. IMHO hogging is a "use" of a GPIO that should
> > prevent it being requested.
> 
> I disagree with you here. The original patch stated in its description
> that it was designed to initialize GPIOs. In my understanding this does
> not necessarily mean that a hogged GPIO has to be blocked forever.

IIRC, this use case was discussed but was rejected by Linus when hogs
were added:

	https://lkml.kernel.org/r/CACRpkdZcNcPBYQM438CZJx1gYst9BFBSTj-3Qv2aPGF9pdWa5g at mail.gmail.com

Linus?

Johan